﻿// MPIMessagePassing.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include "FSendRecv.h"
#include "FSsendRecv.h"
#include "FBsendRecv.h"
#include "FRsendRecv.h"
#include "InitRandom.h"

#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

//====================================================
// Описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================

int main(int argc, char* argv[])
{
	// Инициализация среды параллельных вычислений MPI.
	MPI_Init(NULL, NULL);

	// Получение ранга текущего процесса в группе запущенных приложений.
	// MPI_COMM_WORLD - коммуникатор, объединяющий все процессы в группе.
	int rank = -1;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);

	// Получение количества приложений в группе.
	int count_processes = -1;
	MPI_Comm_size(MPI_COMM_WORLD, &count_processes);

	// Инициализация последовательности псевдослучайных чисел.
	InitRandom(MPI_Wtime());

	// Граница вывода процесса
	std::cout << "============================== Rank " << rank << " ==============================\n";

	// Селектор выбора режима отправки.
	if (argc > 1 && strcmp(argv[1], "ssend") == 0)
	{
		std::cout << "***** MPI_SSEND() *****\n";

		BlockingSsendRecv(rank, count_processes);
	}
	else if (argc > 1 && strcmp(argv[1], "bsend") == 0)
	{
		std::cout << "***** MPI_BSEND() *****\n";

		BlockingBsendRecv(rank, count_processes);
	}
	else if (argc > 1 && strcmp(argv[1], "rsend") == 0)
	{
		std::cout << "***** MPI_RSEND() *****\n";

		BlockingRsendRecv(rank, count_processes);
	}
	else
	{
		std::cout << "***** MPI_SEND() *****\n";

		BlockingSendRecv(rank, count_processes);
	}

	// Граница вывода процесса
	std::cout << "============================== /Rank " << rank << " =============================\n";

	// Завершение работы среды параллельных вычислений MPI.
	MPI_Finalize();

	// Приостановка консольного окна перед закрытием для 
	// тестирования программного кода в студии.
	//std::cin.get();

	_CrtDumpMemoryLeaks();
}